Index: apps/app_dial.c
===================================================================
RCS file: /usr/cvsroot/asterisk/apps/app_dial.c,v
retrieving revision 1.173
diff -u -r1.173 app_dial.c
--- apps/app_dial.c     20 Oct 2005 16:42:53 -0000      1.173
+++ apps/app_dial.c     22 Oct 2005 00:34:29 -0000
@@ -300,6 +300,10 @@
        struct ast_channel *winner;
        char *context = NULL;
        char cidname[AST_MAX_EXTENSION];
+       char tmpchan[256];
+       char *stuff;
+       char *tech;
+       char *forward_context;
                                                                                                                         
        single = (outgoing && !outgoing->next && !ast_test_flag(outgoing, DIAL_MUSICONHOLD | DIAL_RINGBACKONLY));
                                                                                                                         
@@ -357,16 +361,14 @@
                                }
                        } else if (o->chan && (o->chan == winner)) {
                                if (!ast_strlen_zero(o->chan->call_forward)) {
-                                       char tmpchan[256];
-                                       char *stuff;
-                                       char *tech;
                                        ast_copy_string(tmpchan, o->chan->call_forward, sizeof(tmpchan));
                                        if ((stuff = strchr(tmpchan, '/'))) {
                                                *stuff = '\0';
                                                stuff++;
                                                tech = tmpchan;
                                        } else {
-                                               snprintf(tmpchan, sizeof(tmpchan), "%s@%s", o->chan->call_forward, o->chan->context);
+                                               forward_context = pbx_builtin_getvar_helper(o->chan, "FORWARD_CONTEXT");
+                                               snprintf(tmpchan, sizeof(tmpchan), "%s@%s", o->chan->call_forward, forward_context ? forward_context : o->chan->context);
                                                stuff = tmpchan;
                                                tech = "Local";
                                        }

